﻿namespace ProjectGasolineTanker;
/// <summary>
/// Класс-сущность "Бензовоз"
/// </summary>
public class EntityGasolineTanker
{
    /// <summary>
    /// Скорость
    /// </summary>
    public int Speed { get; private set; }
    /// <summary>
    /// Вес
    /// </summary>
    public double Weight { get; private set; }
    /// <summary>
    /// Основной цвет
    /// </summary>
    public Color BodyColor { get; private set; }
    /// <summary>
    /// Дополнительный цвет (для опциональных элементов)
    /// </summary>
    public Color AdditionalColor { get; private set; }
    /// <summary>
    /// Признак (опция) наличия бака под бензин
    /// </summary>
    public bool GasTank { get; private set; }
    /// <summary>
    /// Признак (опция) наличия сигнального маяка на кабине
    /// </summary>
    public bool SignalBeacon { get; private set; }
    /// <summary>
    /// Шаг перемещения бензовоза
    /// </summary>
    public double Step => Speed * 700 / Weight;
    /// <summary>
    /// Инициализация полей объекта-класса бензовоза
    /// </summary>
    /// <param name="speed">Скорость</param>
    /// <param name="weight">Вес</param>
    /// <param name="bodyColor">Основной цвет</param>
    /// <param name="additionalColor">Дополнительный цвет</param>
    /// <param name="gasTank">Признак наличия бака под бензин</param>
    /// <param name="signalBeacon">Признак наличия сигнального маяка на кабине</param>
    public void Init(int speed, double weight, Color bodyColor, Color additionalColor, bool gasTank, bool signalBeacon)
    {
        Speed = speed;
        Weight = weight;
        BodyColor = bodyColor;
        AdditionalColor = additionalColor;     
        GasTank = gasTank;
        SignalBeacon = signalBeacon;

    }
 
}
