﻿namespace ProjectGasolineTanker;
/// <summary>
/// Форма работы с объектом "Бензовоз"
/// </summary>
public partial class FormGasolineTanker : Form
{
    /// <summary>
    /// Поле-объект для прорисовки объекта
    /// </summary>
    private DrawingGasolineTanker? _drawingGasolineTanker;
    /// <summary>
    /// Конструктор формы
    /// </summary>
    public FormGasolineTanker()
    {
        InitializeComponent();
    }

    /// <summary>
    /// Метод прорисовки машины
    /// </summary>
    private void Draw()
    {
        if (_drawingGasolineTanker == null)
        {
            return;
        }
        Bitmap bmp = new(pictureBoxGasolineTanker.Width, pictureBoxGasolineTanker.Height);
        Graphics gr = Graphics.FromImage(bmp);
        _drawingGasolineTanker.DrawTransport(gr);
        pictureBoxGasolineTanker.Image = bmp;
    }

    /// <summary>
    /// Обработка нажатия кнопки "Создать"
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void ButtonCreateGasolineTanker_Click(object sender, EventArgs e)
    {
        Random random = new();
        _drawingGasolineTanker = new DrawingGasolineTanker();
        _drawingGasolineTanker.Init(random.Next(10, 50), random.Next(1000, 5000),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)));

        _drawingGasolineTanker.SetPictureSize(pictureBoxGasolineTanker.Width, pictureBoxGasolineTanker.Height);
        _drawingGasolineTanker.SetPosition(random.Next(10, 100), random.Next(10, 100));

        Draw();

    }
    /// <summary>
    /// Перемещение объекта по форме (кнопки навигации)
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void ButtonMove_Click(object sender, EventArgs e)
    {
        if (_drawingGasolineTanker == null)
        {
            return;
        }

        string name = ((Button)sender)?.Name ?? string.Empty;
        bool result = false;
        switch (name)
        {
            case "buttonUp":
                result = _drawingGasolineTanker.MoveTransport(DirectionType.Up);
                break;
            case "buttonDown":
                result = _drawingGasolineTanker.MoveTransport(DirectionType.Down);
                break;
            case "buttonRight":
                result = _drawingGasolineTanker.MoveTransport(DirectionType.Right);
                break;
            case "buttonLeft":
                result = _drawingGasolineTanker.MoveTransport(DirectionType.Left);
                break;
        }
        if (result)
        {
            Draw();
        }
    }
}

